<?php

class Custom_Blog_Helper_Url extends Magpleasure_Blog_Helper_Url
{
    public function getUrl($id = null, $route = self::ROUTE_POST, $page = 1)
    {
        $storeId = $this->getStoreId() ? $this->getStoreId() : Mage::app()->getStore()->getId();
        $baseUrl = Mage::app()->getStore($storeId)->getBaseUrl('link');
        $url = $baseUrl.$this->getRoute();

        if ($id){

            if ($route == self::ROUTE_POST){

                /** @var Magpleasure_Blog_Model_Post $post  */
                $post = Mage::getModel('mpblog/post');
                $post->load($id);
                if ($post->getUrlKey()){
                    $url .= "/".$post->getUrlKey();
                }


            } elseif ($route == self::ROUTE_CATEGORY) {

                /** @var Magpleasure_Blog_Model_Category $category  */
                $category = Mage::getModel('mpblog/category');
                $category->load($id);
                if ($category->getUrlKey()){
                    $url .= "/".$category->getUrlKey();
                }

            } elseif ($route == self::ROUTE_TAG) {
                /** @var Magpleasure_Blog_Model_Tag $category  */
                $tag = Mage::getModel('mpblog/tag');
                $tag->load($id);
                $url .= "/".self::ROUTE_TAG."/". urlencode($tag->getUrlKey());

            } elseif ($route == self::ROUTE_ARCHIVE) {

                $url .= "/".self::ROUTE_ARCHIVE."/". $id;

            }

        } else {

            if ($route == self::ROUTE_SEARCH){

                $url .= "/".self::ROUTE_SEARCH;
            }
        }

        $url .= $this->getUrlPostfix($page);

        return $url;
    }

    public function getCategoryId($identifier, $page = 1)
    {
        $clean = $this->_cleanUrl($identifier, $page);

        /*if (strpos($clean, "/") === false){
            return false;
        }*/

        $parts = explode("/", $clean);

        /*if ( (count($parts) != 2) || $parts[0] !== self::ROUTE_CATEGORY ){
            return false;
        }*/

        if(array_key_exists(1,$parts)) {
            if($parts[0] !== self::ROUTE_CATEGORY) {
                return false;
            } else {
                $categoryUrlKey = $parts[1];
            }
        } else {
            $categoryUrlKey = $parts[0];
        }

        /** @var Magpleasure_Blog_Model_Mysql4_Category_Collection $collection  */
        $collection = Mage::getModel('mpblog/category')->getCollection();

        $collection
            ->addFieldToFilter('status', Magpleasure_Blog_Model_Category::STATUS_ENABLED)
            ->addFieldToFilter('url_key', $categoryUrlKey)
        ;

        if (!Mage::app()->isSingleStoreMode()){
            $collection->addStoreFilter(Mage::app()->getStore()->getId());
        }

        foreach ($collection as $category){
            return $category->getId();
        }

        return false;
    }
}