<?php

require_once Mage::getModuleDir('controllers', 'Magpleasure_Blog') . DS . 'Adminhtml' . DS . 'Mpblog' . DS . 'PostController.php';

class Custom_Blog_Adminhtml_Mpblog_PostController extends Magpleasure_Blog_Adminhtml_Mpblog_PostController
{
    public function saveAction()
    {
        $this->_resetDraft();
        $requestPost = $this->getRequest()->getPost();

        /** @var Magpleasure_Blog_Model_Post $post */
        $post = Mage::getModel('mpblog/post');
        if ($id = $this->getRequest()->getParam('id')) {
            $post->load($id);
        }

        if($post_products_ids = $this->getRequest()->getParam('selected_products_ids', null)) {
            $post_products_ids = Mage::helper('adminhtml/js')->decodeGridSerializedInput($post_products_ids);
        }

        if(array_key_exists('in_post', $requestPost)) {
            unset($requestPost['in_post']);
        }
        if(array_key_exists('selected_products_ids', $requestPost)) {
            unset($requestPost['selected_products_ids']);
        }
        if(array_key_exists('product_status', $requestPost)) {
            unset($requestPost['product_status']);
        }

        try {
            if ($this->_helper()->getStoreHelper()->isStoreFilterApplied()) {
                unset($requestPost['stores']);
            }
            $post->addData($requestPost);

            # Process Timezone
            if (($post->getUserDefinePublish() || $post->getId() || $post->getId()) && $post->getPublishedAt()) {
                $datetimeFormat = Mage::app()->getLocale()->getDateTimeFormat(Mage_Core_Model_Locale::FORMAT_TYPE_SHORT);
                $publishedAt = new Zend_Date($post->getPublishedAt(), $datetimeFormat);
                $publishedAt->addSecond($this->_helper()->getTimezoneOffset());
                $post->setPublishedAt($publishedAt->toString(Varien_Date::DATETIME_INTERNAL_FORMAT));
            }

            $post->save();

            if(isset($post_products_ids)) {
                $insert_rows = array();
                if($id) {
                    $post_id = $id;
                } else {
                    $post_id = $post->getId();
                }

                $post_products = Mage::getResourceModel('customblog/products_collection')->addFieldToFilter('post_id', $post_id);
                foreach ($post_products as $item) {
                    $item->delete();
                }

                foreach ($post_products_ids as $post_product_id) {
                    $insert_rows[] = array('post_id' => $post_id, 'product_id' => $post_product_id);
                }

                if(count($insert_rows)) {
                    $post_product = Mage::getSingleton('core/resource')->getConnection('core_write');
                    $post_product->insertMultiple('mp_blog_posts_products', $insert_rows);
                }
            }

            $this->_getSession()->addSuccess($this->_helper()->__("Post was successfully saved."));

            $params = $this->_getCommonParams();
            if ($this->getRequest()->getParam('back')) {
                $params['id'] = $this->getRequest()->getParam('id') ? $this->getRequest()->getParam('id') : $post->getId();
                $params['tab'] = $this->getRequest()->getParam('tab');
                $this->_redirect('*/*/edit', $params);
            } else {
                $this->_redirect('*/*/index', $params);
            }

        } catch (Exception $e) {
            Mage::getSingleton('adminhtml/session')->setPostData($requestPost);
            $this->_getSession()->addError($this->_helper()->__("Error while saving the post. %s", $e->getMessage()));
            $this->_redirectReferer();
        }

    }
}
